diff -Naur test-for-latech/kernel/diffs testqf-for-latech/kernel/diffs
--- test-for-latech/kernel/diffs	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/kernel/diffs	2004-06-11 07:47:23.000000000 -0400
@@ -0,0 +1,923 @@
+51a52,56
+> #ifdef CONFIG_DWCS_DFS
+> #include <linux/slab.h>
+> #endif
+> 
+> //#define DWCS_DEBUG_ON 1
+81a87,90
+> MODULE_AUTHOR("Georgia Tech -- CoC");
+> MODULE_DESCRIPTION("DWCS Scheduler");
+> MODULE_LICENSE("GPL");
+> 
+117a127,139
+> 
+> #ifdef CONFIG_DWCS_DFS
+> #define MAX_LONG (unsigned long)4294967295
+> unsigned int start_time;
+> struct task_struct *dwcs_hyper_period_task = NULL;
+> unsigned long int dwcs_hyper_period_old_violations = 0;
+> unsigned long int dwcs_hyper_period_old_misses = 0;
+> unsigned long int dwcs_hyper_period_old_idles = 0;
+> unsigned long int dwcs_hyper_period_violations = 0;
+> unsigned long int dwcs_hyper_period_misses = 0;
+> unsigned long int dwcs_hyper_period_idles = 0;
+> int dwcs_hyper_period_task_iterations = 0;
+> int dwcs_hyper_period_task_count = 0;
+118a141,142
+> 
+> #ifdef CONFIG_ARCH_ADIFCC
+122a147,153
+> #endif
+> 
+> #ifdef CONFIG_ARCH_SA1100
+> int current_sa1100_freq;
+> unsigned int sa1100_freq[12] = {59000, 73700, 88500, 103200, 118000, 132700, 147500, 162200, 176900, 191700, 206400, 221200};
+> #endif
+> #endif
+123a155,160
+> /* Needed for delayed runqueue insertion */
+> static int first_dwcs_task = 1;
+> #ifdef CONFIG_DWCS_DFS
+> static int hyper_period_recalc_needed = 0;
+> 
+> #endif
+131a169,188
+> #ifdef DWCS_DEBUG_ON
+> struct proc_dir_entry *proc_dwcs_debug_control;
+> struct proc_dir_entry *proc_dwcs_debug_write;
+> struct proc_dir_entry *proc_time;
+> #endif
+> #ifdef CONFIG_DWCS_DFS
+> struct proc_dir_entry *proc_dwcs_dfs;
+> #endif
+> #ifdef DWCS_DEBUG_ON
+> extern unsigned long dwcs_timer_max_time;
+> extern long dwcs_max_counter;
+> extern long dwcs_pid;
+> extern unsigned long dwcs_sched_max_time;
+> 
+> int DWCS_DEBUG;
+> char *debug_area;
+> int deb_pos;
+> int debug_count;
+> #endif
+> 
+174a232
+> #ifdef CONFIG_DWCS_DFS
+194a253,452
+> #endif
+> 
+> #ifdef CONFIG_DWCS_DFS
+> static int clk2mhz (int n) 
+> {
+> 	switch(n) {
+> 		case 4 : return 400;
+> 		case 5 : return 466;
+> 		case 6 : return 533;
+> 		case 7 : return 600;
+> 		case 8 : return 666;
+> 		case 9 : return 733;
+> 		default: return -1;
+> 	}
+> 
+> 	return 400;
+> }
+> #endif
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> static unsigned long euclid (unsigned long m, unsigned long n) 
+> {
+> 	unsigned long r;
+> 
+> 	r = m % n;
+> 	if (!r) {
+> 		return n;
+> 	}
+> 	return euclid (n, r);
+> }
+> #endif
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> static unsigned long least_common_period (unsigned long x, unsigned long y)
+> {
+> 	return ((x * y) / euclid (x, y));	
+> }
+> #endif
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> static int find_smallest (unsigned long *period, int size)
+> {
+> 	int i;
+> 	int index = -1;
+> 	unsigned long smallest = MAX_LONG;
+> 
+> 	for (i = 0; i < size; i++) {
+> 		if (period[i] < smallest) {
+> 			index = i;
+> 			smallest = period[i];
+> 		}
+> 	}
+> 
+> 	return index;
+> }
+> #endif			
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> static void find_hyper_period_task (void)
+> {
+> 	int i;
+> 	int lcp;
+> 	unsigned long largest_period;
+> 	unsigned long *period;
+> 	int dwcs_task_count;
+> 	int smallest_index;
+> 	struct task_struct *temp;
+> 
+> 	dwcs_task_count = 0;
+> 	largest_period = 0;
+> 	for_each_task (temp) {
+> 		if ((int)temp->dwcs_params->period > 0) {
+> 			dwcs_task_count++;
+> 			if ((int)temp->dwcs_params->period > largest_period) {
+> 				dwcs_hyper_period_task = temp;
+> 				largest_period = temp->dwcs_params->period;
+> 			}
+> 		}
+> 	}
+> 	if (dwcs_task_count == 1)
+> 		start_time = jiffies;
+> 
+> 	period = kmalloc (dwcs_task_count * sizeof (unsigned long), GFP_KERNEL);
+> 	for (i = 0; i < dwcs_task_count; i++)
+> 		period[i] = MAX_LONG;
+> 	i = 0;
+> 	for_each_task (temp) {
+> 		if ((int)temp->dwcs_params->period > 0) {
+> 			period[i] = temp->dwcs_params->period;
+> 			i++;
+> 		}
+> 	}
+> 
+> 	lcp = 1;
+> 	for (i = 0; i < dwcs_task_count; i++) {
+> 		smallest_index = find_smallest (period, dwcs_task_count);
+> 		lcp = least_common_period (lcp, period[smallest_index]);
+> 		period[smallest_index] = MAX_LONG;
+> 	}
+> 
+> 	dwcs_hyper_period_task_iterations = lcp / largest_period;
+> 	dwcs_hyper_period_task_count = 0;
+> 	
+> 
+> 	printk (KERN_DEBUG "Hyper Task PID = %d\tLeast Common Period = %d\n", dwcs_hyper_period_task->pid, lcp);
+> 
+> 	kfree (period);
+> 
+> 	hyper_period_recalc_needed = 0;
+> }
+> #endif
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> void dwcs_dfs_measurements (struct task_struct *p)
+> {
+> 	int misses;
+> 	int violations;
+> 	int idles;
+> 	static int freq_change;
+> 	volatile unsigned int cclkcfg;
+> 
+> 	if (hyper_period_recalc_needed)
+> 		find_hyper_period_task();
+> 
+> 				/* Make any scaling adjustments */
+> 	misses = dwcs_hyper_period_misses - dwcs_hyper_period_old_misses;
+> 	violations = dwcs_hyper_period_violations - dwcs_hyper_period_old_violations;
+> 	idles = dwcs_hyper_period_idles - dwcs_hyper_period_old_idles;
+> 
+> 	freq_change = 0;
+> 	if (violations > 0) {
+> #ifdef CONFIG_ARCH_ADIFCC
+> 		get_80200_CCLKCFG(cclkcfg);
+> 		if (cclkcfg < 9) {
+> 		/*	cclkcfg += violations;	*/
+> 			cclkcfg++;
+> 			if (cclkcfg > 9)
+> 				cclkcfg = 9;
+> 			set_80200_CCLKCFG(cclkcfg);
+> 			freq_change = 1;
+> 		}
+> #endif
+> #ifdef CONFIG_ARCH_SA1100
+> 		if (current_sa1100_freq < 12) {
+> 			current_sa1100_freq++;
+> 			cpufreq_set (sa1100_freq[current_sa1100_freq]);
+> 			freq_change = 1;
+> 		}	
+> #endif
+> 	}
+> 	else if ((misses > 0) && (violations == 0)) {
+> #ifdef CONFIG_ARCH_ADIFCC
+> 	/*
+> 		get_80200_CCLKCFG(cclkcfg);
+> 		if (cclkcfg < 9) {
+> 			cclkcfg++;
+> 			set_80200_CCLKCFG(cclkcfg); 
+> 			freq_change = 1;
+> 		}
+> 	*/
+> #endif
+> #ifdef CONFIG_ARCH_SA1100
+> 
+> #endif
+> 	}
+> 	else if ((violations == 0) && (misses == 0)) {
+> #ifdef CONFIG_ARCH_ADIFCC
+> 		get_80200_CCLKCFG(cclkcfg);
+> 		if (cclkcfg > 4) {
+> 			cclkcfg--;
+> 			set_80200_CCLKCFG(cclkcfg);
+> 			freq_change = 1;
+> 		}
+> #endif
+> #ifdef CONFIG_ARCH_SA1100
+> 		if (current_sa1100_freq > 0) {
+> 			current_sa1100_freq--;
+> 			cpufreq_set (sa1100_freq[current_sa1100_freq]);
+> 			freq_change = 1;
+> 		}
+> #endif
+> 	}
+> 
+> 	if (freq_change) {
+> 		printk (KERN_DEBUG "%lu\t %d\t %d\t %d\t %d\t %d\n", 
+> 				jiffies - start_time, clk2mhz(cclkcfg), violations, misses, idles, utilization);
+> 	}
+> 						
+> 	dwcs_hyper_period_old_violations = dwcs_hyper_period_violations;
+> 	dwcs_hyper_period_old_idles = dwcs_hyper_period_idles;
+> 	dwcs_hyper_period_old_misses = dwcs_hyper_period_misses;
+> 
+> }
+> #endif
+> 
+196c454,540
+< /* calculates max. possble slowdown and calls do_set_slowest_cpuspeed */
+---
+> #ifdef CONFIG_DWCS_DFS
+> void dwcs_dfs_theoretical (void)
+> {
+> #ifdef CONFIG_ARCH_ADIFCC
+> 	unsigned int freq_matrix[6][6] = {{1000,  857,  749,  666,  599,  545},
+> 			    	 	  {1166, 1000,  874,  777,  699,  636},
+> 			    	 	  {1333, 1142, 1000,  888,  799,  727},
+> 			    	 	  {1500, 1285, 1125, 1000,  899,  818},
+> 			    	 	  {1666, 1428, 1250, 1111, 1000,  909},
+> 			    	 	  {1832, 1570, 1373, 1221, 1099, 1000}};
+> 	volatile unsigned int cclkcfg;
+> #endif
+> #ifdef CONFIG_ARCH_SA1100
+> 	unsigned int freq_matrix[12][12] = {
+> 		{1000,  792,  649,  552,  480,  425,  381,  343,  314,  289,  268,  268},
+> 		{1262, 1000,  820,  697,  606,  536,  481,  433,  396,  365,  339,  339},
+> 		{1538, 1219, 1000,  850,  739,  654,  587,  528,  483,  445,  413,  413},
+> 		{1809, 1433, 1175, 1000,  869,  769,  690,  621,  568,  524,  486,  486},
+> 		{2080, 1648, 1351, 1149, 1000,  884,  793,  714,  653,  602,  559,  559},
+> 		{2352, 1863, 1528, 1299, 1130, 1000,  897,  807,  739,  681,  632,  632},
+> 		{2621, 2077, 1703, 1448, 1260, 1114, 1000,  899,  823,  759,  704,  704},
+> 		{2913, 2308, 1893, 1609, 1400, 1238, 1111, 1000,  915,  844,  783,  783},
+> 		{3182, 2521, 2067, 1758, 1529, 1353, 1213, 1092, 1000,  922,  855,  855},
+> 		{3451, 2734, 2242, 1907, 1659, 1467, 1316, 1184, 1084, 1000,  928,  928},
+> 		{3719, 2947, 2416, 2055, 1787, 1581, 1418, 1276, 1168, 1077, 1000, 1000},
+> 		{3719, 2947, 2416, 2055, 1787, 1581, 1418, 1276, 1168, 1077,  999, 1000}};
+> 
+> #endif
+> 
+> 	
+> 	int i;
+> 	int closest_freq = -1;
+> 	int smallest_difference;
+> 	int current_freq;
+> 	int k_entries;
+> 
+> 	smallest_difference = MAX_UTILIZATION;
+> 
+> #ifdef CONFIG_ARCH_SA1100
+> 	current_freq = 11;
+> 	k_entries = 12;
+> #endif
+> #ifdef CONFIG_ARCH_ADIFCC
+> 	current_freq = 5;
+> 	k_entries = 6;
+> #endif
+> 	
+> 	for (i = 0; i < k_entries; i++) {
+> 		int temp_utilization;
+> 		 
+> 		temp_utilization = (utilization * freq_matrix[current_freq][i]);
+> 		temp_utilization = temp_utilization / 1000;
+> 		temp_utilization = (MAX_UTILIZATION - reserved_utilization) - temp_utilization;
+> 		if ((temp_utilization >= 0) && (temp_utilization < smallest_difference)) {
+> 			smallest_difference = temp_utilization;
+> 			closest_freq = i;
+> 		}
+> 		/*
+> 		printk (KERN_DEBUG "U = %d\t M = %d\t TU = %d\t SD = %d\n", utilization, freq_matrix[current_freq][i],
+> 				temp_utilization, smallest_difference);
+> 		*/
+> 	}
+> 
+> 	if (closest_freq > 0) {
+> #ifdef CONFIG_ARCH_ADIFCC
+> 		closest_freq += 4;
+> 		get_80200_CCLKCFG(cclkcfg);
+> 		if ((unsigned)closest_freq != cclkcfg) {
+> 			cclkcfg = (unsigned) closest_freq;
+> 			set_80200_CCLKCFG (cclkcfg);
+> 			printk (KERN_DEBUG "%ld\t %ld\n", JIFFIES - start_time, clk2mhz (cclkcfg));
+> 		}
+> #endif
+> #ifdef CONFIG_ARCH_SA1100
+> 		if (cpufreq_get(0) != sa1100_freq[closest_freq]) {
+> 			cpufreq_set (sa1100_freq[closest_freq]);
+> 		}
+> #endif
+> 	}
+> 
+> 	return;
+> }
+> #endif
+> 
+> 
+> #ifdef CONFIG_DWCS_DFS
+> /* calculates max. possible slowdown and calls do_set_slowest_cpuspeed */
+205a550
+> #endif
+241a587,640
+> #ifdef DWCS_DEBUG_ON
+> static int proc_dwcs_debug_c_read(char *page, char **start, off_t off,				  int count, int *eof, void *data){
+>   int len;
+>   MOD_INC_USE_COUNT;
+>   len = sprintf(page, "%d\n", DWCS_DEBUG);
+>   MOD_DEC_USE_COUNT;
+>   return len;
+> }
+> 
+> static int proc_dwcs_debug_c_write(struct file *file, const char *buffer, unsigned long count, void *data){
+>   unsigned char value;
+>   MOD_INC_USE_COUNT;
+> 
+>   if(copy_from_user(&value, buffer, 1)){
+>     MOD_DEC_USE_COUNT;
+>     return -EFAULT;
+>   }
+>   if(value == '0'){
+>     if(DWCS_DEBUG == 1){
+>       kfree(debug_area);
+>     }
+>     DWCS_DEBUG = 0;
+>     printk("Disabling verbose debugging!\n");
+>   }
+>   else if(value == '1'){
+>       DWCS_DEBUG = 1;
+>       deb_pos = 0;
+>       debug_count = 0;
+>       debug_area = (char *)kmalloc(50*sizeof(char *)*100, GFP_KERNEL);
+>       memset(debug_area, '\0', sizeof(debug_area));
+>       printk("Enabling verbose debugging!\n");
+>   }
+> 
+>   MOD_DEC_USE_COUNT;
+> 
+>   return 1;
+> }
+> 
+> int proc_dwcs_debug_info_read(char *buf, char **start, off_t offset, int len, int *eof, void *data){
+>   len = 0;
+>   len += sprintf(buf+len,  "pid   deadline   current time   period   own   owd   cwn   cwd   flags   ready_time   service_time   time_serviced   wlate   late   on_time   violation\n");
+>   /* len += sprintf(buf+len, "%s\n", debug_area); */
+>   len += strlen(strncat(buf+len, debug_area, 500*100*sizeof(char *)));
+>   return len;
+> }
+> 
+> int proc_time_read(char *buf, char **start, off_t offset, int len, int *eof, void *data){
+>   len = 0;
+>   len += sprintf(buf+len, "pid %ld\ntimer time %lu\ncounter %lu\nsched %lu\n", dwcs_pid, dwcs_timer_max_time, dwcs_max_counter, dwcs_sched_max_time);
+>   dwcs_sched_max_time = 0;
+>   return len;
+> }
+> #endif
+> 		  
+279a679,695
+> #ifdef CONFIG_DWCS_DFS
+> static int proc_dwcs_dfs_read (char *page, char **start, off_t off,
+> 					int count, int *eof, void *data)
+> {
+> 	int len;
+> 	volatile unsigned int cclkcfg;
+> 	
+> 	MOD_INC_USE_COUNT;
+> 	get_80200_CCLKCFG(cclkcfg);
+> 	len = sprintf (page, "\tFrequency = %d\n\tMisses = %ld\n\tViolations = %ld\n\tIdles = %ld\n", 
+> 			cclkcfg, dwcs_hyper_period_misses, dwcs_hyper_period_violations, dwcs_hyper_period_idles);
+> 	MOD_DEC_USE_COUNT;
+> 	return len;
+> }
+> #endif
+> 
+> 
+340a757,903
+> 
+> 
+> 
+> static void runqueue_insert (struct dwcs_sched_param sp, int first_dwcs_process)
+> {
+> #ifdef CONFIG_DWCS_DFS
+> 	volatile unsigned int cclkcfg;
+> #endif
+> 	struct task_struct *p;
+> 
+> 
+> 	if (sp.pid < 0)
+> 		goto runqueue_out_nounlock;
+> 
+> 	/*
+> 	 * We play safe to avoid deadlocks.
+> 	 */
+> 	read_lock_irq(&tasklist_lock);
+> 	spin_lock(&runqueue_lock);
+> 
+> 	p = find_task_by_pid(sp.pid);
+> 
+> #ifdef CONFIG_QFABRIC
+> 	if ((DWCS_module_loaded) && (DWCS_admission_control)) {
+> 		printk (KERN_DEBUG "Requesting admission!\n");
+> 		/* --FS-- is this shortcut leagl? */
+> 		if (DWCS_request_admission(p, &sp) < 0)
+> 			goto runqueue_out_unlock;
+> 	}
+> #endif
+> 
+> 	if (!p)
+> 		goto runqueue_out_unlock;
+> 	if (sp.policy < 0)
+> 		sp.policy = p->policy;
+> 	else {
+> 		if (sp.policy != SCHED_FIFO && sp.policy != SCHED_RR &&
+> 		    sp.policy != SCHED_OTHER && sp.policy != SCHED_DWCS)
+> 			goto runqueue_out_unlock;
+> 	}
+> 
+> 		/* Begin of DWCS specific handling */
+> 	if (sp.policy == SCHED_DWCS) {
+> 		/* --CP--
+> 		 * Set flag for computation of utilization.
+> 		 */
+> 		DWCS_update_utilization = 1;
+> 
+> 		/* Check ranges of scheduling parameters. */
+> 		/* The following should never be true, since `own' and `owd'
+> 		 * are `unsigned'. */
+> 		if ((sp.own < 0) || (sp.owd < 0))
+> 			goto runqueue_out_unlock;
+> 
+> 		/* Restrict who can set scheduling parameters. */
+> 		if (!capable(CAP_SYS_NICE))
+> 			goto runqueue_out_unlock;
+> 
+> 		/*
+> 		 * --RW--
+> 		 * Should really set p->policy = SCHED_DWCS, so that
+> 		 * sched_setparam() works with DWCS. But, if we no
+> 		 * longer use DWCS, we need to set p->policy to SCHED_OTHER.
+> 		 */
+> 		p->dwcs_params->period = sp.period;
+> 		p->dwcs_params->own    = sp.own;
+> 		p->dwcs_params->owd    = sp.owd;
+> 		if (sp.period == (unsigned long)-1) {
+> 			p->dwcs_params->deadline   = (unsigned long)-1;
+> 			p->dwcs_params->flags     |= DWCS_WORK_CONS;
+> 			p->dwcs_params->ready_time = 0;
+> 		}
+> 		else {
+> 			if (first_dwcs_process) {
+> 				p->dwcs_params->deadline   = jiffies + sp.period;
+> 				p->dwcs_params->ready_time = jiffies;
+> 			}
+> 			else {
+> #ifdef CONFIG_DWCS_DFS
+> 				unsigned long new_ready_time;
+> 				
+> 	                        new_ready_time = dwcs_hyper_period_task->dwcs_params->deadline;
+> 	                        while ((new_ready_time - sp.period) > JIFFIES)
+> 		                	new_ready_time -= sp.period;
+> 	                        p->dwcs_params->ready_time = new_ready_time;
+> 	                        p->dwcs_params->deadline = new_ready_time + sp.period;
+> 				hyper_period_recalc_needed = 1;
+> #else
+> 	                        p->dwcs_params->ready_time = jiffies;
+> 	                        p->dwcs_params->deadline = p->dwcs_params->ready_time 
+> 					+ sp.period;
+> #endif
+> 			}			
+> 			if (sp.flags & DWCS_WORK_CONS)
+> 				p->dwcs_params->flags   |= DWCS_WORK_CONS;
+> 			else
+> 				p->dwcs_params->flags   &= ~DWCS_WORK_CONS;
+> 		}
+> 
+> 		if (sp.flags & DWCS_NON_PREEMPTIVE)
+> 			p->dwcs_params->flags |= DWCS_NON_PREEMPTIVE;
+> 		else if (sp.flags == 0) 
+> 			p->dwcs_params->flags &= ~(DWCS_WORK_CONS | DWCS_NON_PREEMPTIVE);
+> 
+> 		p->dwcs_params->service_time = sp.service_time;
+> 		p->dwcs_params->cwn          = sp.own;
+> 		p->dwcs_params->cwd          = sp.owd;
+> 
+> 		if (task_on_runqueue(p))
+> 			move_first_runqueue(p);
+> 		current->need_resched = 1;
+> 			
+> 
+> 		goto runqueue_out_unlock;
+> 	}
+> 	/* End of DWCS specific handling */
+> 
+> 	/*
+> 	 * Valid priorities for SCHED_FIFO and SCHED_RR are 1..99, valid
+> 	 * priority for SCHED_OTHER is 0.
+> 	 */
+> 	if (sp.sched_priority < 0 || sp.sched_priority > 99)
+> 		goto runqueue_out_unlock;
+> 	if ((sp.policy == SCHED_OTHER) != (sp.sched_priority == 0))
+> 		goto runqueue_out_unlock;
+> 
+> 	if ((sp.policy == SCHED_FIFO || sp.policy == SCHED_RR) && !capable(CAP_SYS_NICE))
+> 		goto runqueue_out_unlock;
+> 	if ((current->euid != p->euid) && (current->euid != p->uid) && !capable(CAP_SYS_NICE))
+> 		goto runqueue_out_unlock;
+> 
+> 	p->policy = sp.policy;
+> 	p->rt_priority = sp.sched_priority;
+> 	if (task_on_runqueue(p))
+> 		move_first_runqueue(p);
+> 
+> 	current->need_resched = 1;
+> runqueue_out_unlock:
+> 	spin_unlock(&runqueue_lock);
+> 	read_unlock_irq(&tasklist_lock);
+> 
+> runqueue_out_nounlock:
+> 	return;
+> }
+> 
+> 
+> 
+349d911
+< 	printk(KERN_DEBUG "IOCTL called\n");
+377d938
+< 
+388,389c949,950
+< 	case 1: /* set the schedule paramteres for given pid */
+< 		retval = -EFAULT;
+---
+> 		/* Here is where the new DWCS tasks come to be added to the runqueue */
+> 	case 1: 
+391,411c952,959
+< 			goto out_nounlock;
+< 
+< 		retval = -EINVAL;
+< 		if (sp.pid < 0)
+< 			goto out_nounlock;
+< 
+< 		/*
+< 		 * We play safe to avoid deadlocks.
+< 		 */
+< 		read_lock_irq(&tasklist_lock);
+< 		spin_lock(&runqueue_lock);
+< 
+< 		p = find_task_by_pid(sp.pid);
+< 
+< #ifdef CONFIG_QFABRIC
+< 		if ((DWCS_module_loaded) && (DWCS_admission_control)) {
+< 			retval = -EADMISSION;
+< 			/* --FS-- is this shortcut leagl? */
+< 			if (DWCS_request_admission(p, &sp) < 0)
+< 				goto out_unlock;
+< 		}
+---
+> 			return -EINVAL;	
+> 	
+> 		
+> 			/* If this is the first DWCS task, add it to the runqueue immediately */
+> 		if (first_dwcs_task) {
+> 			runqueue_insert (sp, 1);
+> #ifdef CONFIG_DWCS_DFS
+> 			find_hyper_period_task();	
+413,424c961,962
+< 
+< 		retval = -ESRCH;
+< 		if (!p)
+< 			goto out_unlock;
+< 
+< 		if (sp.policy < 0)
+< 			sp.policy = p->policy;
+< 		else {
+< 			retval = -EINVAL;
+< 			if (sp.policy != SCHED_FIFO && sp.policy != SCHED_RR &&
+< 			    sp.policy != SCHED_OTHER && sp.policy != SCHED_DWCS)
+< 				goto out_unlock;
+---
+> 			first_dwcs_task = 0;
+> 			return 0;
+426,486c964,968
+< 
+< 		/* Begin of DWCS specific handling */
+< 		if (sp.policy == SCHED_DWCS) {
+< 
+< 			/* --CP--
+< 			 * Set flag for computation of utilization.
+< 			 */
+< 			DWCS_update_utilization = 1;
+< 
+< 			/* Check ranges of scheduling parameters. */
+< 			retval = -EINVAL;
+< 
+< 			/* The following should never be true, since `own' and `owd'
+< 			 * are `unsigned'. */
+< 			if ((sp.own < 0) || (sp.owd < 0))
+< 				goto out_unlock;
+< 
+< 			/* Restrict who can set scheduling parameters. */
+< 			retval = -EPERM;
+< 			if (!capable(CAP_SYS_NICE))
+< 				goto out_unlock;
+< 
+< 			retval = 0;
+< 			/*
+< 			 * --RW--
+< 			 * Should really set p->policy = SCHED_DWCS, so that
+< 			 * sched_setparam() works with DWCS. But, if we no
+< 			 * longer use DWCS, we need to set p->policy to SCHED_OTHER.
+< 			 */
+< 			p->dwcs_params->period = sp.period;
+< 			p->dwcs_params->own    = sp.own;
+< 			p->dwcs_params->owd    = sp.owd;
+< 			if (sp.period == (unsigned long)-1) {
+< 				p->dwcs_params->deadline   = (unsigned long)-1;
+< 				p->dwcs_params->flags     |= DWCS_WORK_CONS;
+< 				p->dwcs_params->ready_time = 0;
+< 			}
+< 			else {
+< 				p->dwcs_params->deadline   = jiffies + sp.period;
+< 				p->dwcs_params->ready_time = jiffies;
+< 				if (sp.flags & DWCS_WORK_CONS)
+< 					p->dwcs_params->flags   |= DWCS_WORK_CONS;
+< 				else
+< 					p->dwcs_params->flags   &= ~DWCS_WORK_CONS;
+< 			}
+< 
+< 			if (sp.flags & DWCS_NON_PREEMPTIVE)
+< 				p->dwcs_params->flags     |= DWCS_NON_PREEMPTIVE;
+< 			else if (sp.flags == 0) /* Reset. */
+< 				p->dwcs_params->flags     &= ~(DWCS_WORK_CONS |
+< 							       DWCS_NON_PREEMPTIVE);
+< 
+< 			p->dwcs_params->service_time = sp.service_time;
+< 			p->dwcs_params->cwn          = sp.own;
+< 			p->dwcs_params->cwd          = sp.owd;
+< 
+< 			if (task_on_runqueue(p))
+< 				move_first_runqueue(p);
+< 			current->need_resched = 1;
+< 
+< 			goto out_unlock;
+---
+> 			/* If it is not the first DWCS task, delay its entry */
+> 		else {
+> 			runqueue_insert (sp, 0);
+> 			
+> 			return 0;
+488,521c970
+< 		/* End of DWCS specific handling */
+< 
+< 		/*
+< 		 * Valid priorities for SCHED_FIFO and SCHED_RR are 1..99, valid
+< 		 * priority for SCHED_OTHER is 0.
+< 		 */
+< 		retval = -EINVAL;
+< 		if (sp.sched_priority < 0 || sp.sched_priority > 99)
+< 			goto out_unlock;
+< 		if ((sp.policy == SCHED_OTHER) != (sp.sched_priority == 0))
+< 			goto out_unlock;
+< 
+< 		retval = -EPERM;
+< 		if ((sp.policy == SCHED_FIFO || sp.policy == SCHED_RR) &&
+< 		    !capable(CAP_SYS_NICE))
+< 			goto out_unlock;
+< 		if ((current->euid != p->euid) && (current->euid != p->uid) &&
+< 		    !capable(CAP_SYS_NICE))
+< 			goto out_unlock;
+< 
+< 		retval = 0;
+< 		p->policy = sp.policy;
+< 		p->rt_priority = sp.sched_priority;
+< 		if (task_on_runqueue(p))
+< 			move_first_runqueue(p);
+< 
+< 		current->need_resched = 1;
+< 
+< out_unlock:
+< 		spin_unlock(&runqueue_lock);
+< 		read_unlock_irq(&tasklist_lock);
+< 
+< out_nounlock:
+< 		return retval;
+---
+> 		
+547a997
+>  	DWCS_admission_control = 1;	
+570a1021,1049
+> #ifdef DWCS_DEBUG_ON
+> 	proc_dwcs_debug_control = create_proc_entry("debugging_control", 0644, 
+> 		proc_dwcs_dir);
+> 	proc_dwcs_debug_control->owner = THIS_MODULE;
+> 	proc_dwcs_debug_control->write_proc = proc_dwcs_debug_c_write;
+> 	proc_dwcs_debug_control->read_proc = proc_dwcs_debug_c_read;
+> 	
+> 	proc_dwcs_debug_write = create_proc_read_entry("debug_info", 0444, 
+> 		proc_dwcs_dir, proc_dwcs_debug_info_read, NULL);
+> 	proc_dwcs_debug_write->owner = THIS_MODULE;
+> 	proc_time = create_proc_read_entry("time", 0444, proc_dwcs_dir, proc_time_read,
+> 		NULL);
+> 	proc_time->owner = THIS_MODULE;
+> #endif
+> 
+> #ifdef CONFIG_DWCS_DFS
+> 	proc_dwcs_dfs = create_proc_entry("dfs", 0444, proc_dwcs_dir);
+> 	proc_dwcs_dfs->owner = THIS_MODULE;
+> 	proc_dwcs_dfs->read_proc = proc_dwcs_dfs_read;
+> 
+> #ifdef CONFIG_ARCH_SA1100
+> 	current_sa1100_freq = 0;
+> 	do {
+> 		if (cpufreq_get(0) == sa1100_freq[current_sa1100_freq]) break;
+> 		current_sa1100_freq++;
+> 	} while (current_sa1100_freq < 16);
+> #endif	
+> #endif
+> 	
+588a1068,1077
+> 	utilization = 0;
+> 
+> #ifdef DWCS_DEBUG_ON
+> 	if (DWCS_DEBUG) {
+> 		kfree(debug_area);
+> 	}
+> 	remove_proc_entry("time", proc_dwcs_dir);
+> 	remove_proc_entry("debug_info", proc_dwcs_dir);
+> 	remove_proc_entry("debugging_control", proc_dwcs_dir);
+> #endif
+593a1083,1085
+> #ifdef CONFIG_DWCS_DFS
+> 	remove_proc_entry("dfs", proc_dwcs_dir);
+> #endif
+681,683c1173,1178
+< 			/* printk (KERN_DEBUG "(%d) Deadline missed!\n",
+< 			   p->dwcs_params->cd); */
+< 
+---
+> 			/*
+> 			printk (KERN_DEBUG "(%d) Deadline missed! %d\n", p->dwcs_params->cd, JIFFIES - p->dwcs_params->deadline);
+> 			*/
+> #ifdef CONFIG_DWCS_DFS
+> 			dwcs_hyper_period_misses++;
+> #endif
+693,694c1188,1193
+< 					/*printk (KERN_DEBUG "(%d) VIOLATION!\n",
+< 					  p->dwcs_params->cd);*/
+---
+> #ifdef CONFIG_DWCS_DFS
+> 					dwcs_hyper_period_violations++;
+> #endif
+> 					/*
+> 					printk (KERN_DEBUG "(%d) VIOLATION!\n", p->dwcs_params->cd);
+> 					*/
+699a1199
+> 			p->dwcs_params->ready_time += p->dwcs_params->period;
+775c1275
+< 			if (p->dwcs_params->deadline != (unsigned long)-1)
+---
+> 			if (p->dwcs_params->deadline != (unsigned long)-1) {
+776a1277,1288
+> #ifdef CONFIG_DWCS_DFS
+> 				/*
+> 				if (p == dwcs_hyper_period_task) {
+> 					dwcs_hyper_period_task_count++;
+> 					if (dwcs_hyper_period_task_count == dwcs_hyper_period_task_iterations) {
+> 						dwcs_dfs_measurements (p);
+> 						dwcs_hyper_period_task_count = 0;
+> 					}
+> 				}
+> 				*/
+> #endif
+> 			}
+784,787c1296
+< 		if (((p->dwcs_params->on_time +
+< 		      p->dwcs_params->late) %
+< 		     p->dwcs_params->owd) == 0) {
+< 
+---
+> 		if (((p->dwcs_params->on_time + p->dwcs_params->late) % p->dwcs_params->owd) == 0) {
+789a1299,1301
+> #ifdef CONFIG_DWCS_DFS
+> 				dwcs_hyper_period_violations++;
+> #endif
+794a1307,1311
+> 	}
+> #ifdef DWCS_DEBUG_ON
+> 	if (DWCS_DEBUG && (p->dwcs_params->deadline != -1) && (debug_count < 50)) {
+> 		char tmp[100];
+> 		sprintf(tmp, "%d   %ld   %ld   %ld   %d   %d   %d   %d   %d   %ld   %ld   %ld   %d   %ld   %ld   %ld\n", p->pid, p->dwcs_params->deadline, JIFFIES, p->dwcs_params->period, p->dwcs_params->own, p->dwcs_params->owd, p->dwcs_params->cwn, p->dwcs_params->cwd, p->dwcs_params->flags, p->dwcs_params->ready_time, p->dwcs_params->service_time, p->dwcs_params->time_serviced, p->dwcs_params->wlate, p->dwcs_params->late, p->dwcs_params->on_time, p->dwcs_params->violations);
+795a1313
+> 		strcat(debug_area, tmp);
+796a1315
+> #endif
+828c1347
+< 	if ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+---
+> 	/* if ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+831a1351,1353
+> 	*/
+> 	if ((p->dwcs_params->deadline == next->dwcs_params->deadline) &&
+> 		(p->dwcs_params->deadline == (unsigned long) -1)) {
+894c1416
+< 	    ((utilization - old_utilization + new_utilization) > MAX_UTILIZATION))
+---
+> 	    ((utilization - old_utilization + new_utilization) > (MAX_UTILIZATION - reserved_utilization)))
+897d1418
+< 
+915a1437,1440
+> 		printk (KERN_DEBUG "Utilization now %d\n", utilization);
+> #ifdef CONFIG_DWCS_DFS
+> 		dwcs_dfs_theoretical();
+> #endif
+917a1443,1449
+> #ifdef CONFIG_DWCS_DFS
+> 			/*
+> 			if (tptr == dwcs_hyper_period_task) {
+> 				find_hyper_period_task();
+> 			}
+> 			*/
+> #endif
+921a1454,1456
+> #ifdef CONFIG_DWCS_DFS			
+> 			dwcs_dfs_theoretical();
+> #endif
+939a1475
+> 
+1032a1569
+> 	
+1096c1633
+< 		if (can_schedule(p, this_cpu))
+---
+> 		if (can_schedule(p, this_cpu)) {
+1097a1635,1642
+> 		}
+> #ifdef DWCS_DEBUG_ON
+> 		else {
+> 			char tmp[100];
+> 			sprintf(tmp, "no csc\n%d   %ld   %ld   %ld   %d   %d   %d   %d   %d   %ld   %ld   %ld   %d   %ld   %ld   %ld\n", p->pid, p->dwcs_params->deadline, JIFFIES, p->dwcs_params->period, p->dwcs_params->own, p->dwcs_params->owd, p->dwcs_params->cwn, p->dwcs_params->cwd, p->dwcs_params->flags, p->dwcs_params->ready_time, p->dwcs_params->service_time, p->dwcs_params->time_serviced, p->dwcs_params->wlate, p->dwcs_params->late, p->dwcs_params->on_time, p->dwcs_params->violations);
+> 			strcat(debug_area, tmp);
+> 		}
+> #endif
+1113a1659,1666
+> #ifdef DWCS_DEBUG_ON
+> 	if (DWCS_DEBUG && (debug_count < 50)) {
+> 		char tmp[5];
+> 		debug_count++;
+> 		sprintf(tmp, "%d\n", p->pid);
+> 		strcat(debug_area, tmp);
+> 	}
+> #endif
+1140a1694,1698
+> #ifdef CONFIG_DWCS_DFS
+> 	if (next == idle_task(this_cpu)) {
+> 		dwcs_hyper_period_idles++;
+> 	}
+> #endif
+1147a1706
+> /*
+1161d1719
+< 		/* set to default processor speed */
+1164c1722
+< 
+---
+> */
+1172d1729
+< 
